;Battleship - isu version
;Popis:
;Autor: Tomas Goldmann, igoldmann@fit.vutbr.cz
;Date: 16.4.2017, modified: 28.4.2017

%include "rw32-2017.inc"

extern _print_ships
extern @hit_check@8
extern _shot@8
extern _printf
extern _sprintf
extern _fopen
extern _fwrite
extern _fclose
extern _get_pointer_to_shots

section .data

;Informace o lodi jsou ulozeny v polich za sebou
;Kazda polozka obsahuje data v tomto poradi: x,y,sirka,vyska
;Kde x,y je souradnice horniho rohu
;v nize uvedenych datech jsou definovane 3 lode
ships_data dd   16,20,30,70,
           dd   220,200,50,20,
           dd   300,400,70,30

ship_count dd 3
  
;Defined strings:
hit_str db 10,"******Zasah!******",10,0
nohit_str db 10,"******Vedle!******",10,0
wrong_cor db 10,"Strela miri mimo hraci plochu!",10,0


;DULEZITE: Upravte si cestu, kam se ma soubor ulozit, kdyz date jenom nazev souboru ulozi se do slozky temp odkud se spousti prelozeny program
file_name db "D:\isu.txt",0
fopen_flags db "wb",0
sprintf_format db "Ship: x:%d y:%d w:%d h:%d",0
   
area_w dd 500
area_h dd 500
count_hits dd 1

section .bss
;buffer o velikosti 100B pro sprintf 
str_buffer resb 100

section .text
main:
    mov ebp, esp
    
    ;UKOL c.1
    ;Nactete ze vstupu pomoci ReadUInt32 souradnici x a nasledne opet pomoci ReadUInt32 y
    ;Po nacteni vystrelu zavolejte funkci _shot@8, urcete o jakou konveci se jedna a spravne ji pouzijte
    ;Funkce je deklarovana jako: void shot(int x, int y)
    ;Funkce provede zaznamenani pozice cile a bude si ho pamatovat pro dalsi casti prikladu
    ;Nactete ze stdin alespon 3 pozice kam maji dopadnout rakety
    
    mov ecx,5
    cyklus: 
            call ReadUInt32
            mov ebx, eax
            call ReadUInt32
            
            cmp ebx, [area_w]
            jb coordinates_ok
            mov esi, wrong_cor
            call WriteString
            jmp app_end
            
            cmp eax, [area_h]
            jb coordinates_ok
            mov esi, wrong_cor
            call WriteString
            jmp app_end
            
            ;stdcall - funkce Win32API

coordinates_ok: 
            push ecx
            push eax
            push ebx 
            call _shot@8
            pop ecx
    loop cyklus
    
    
    ;UKOL volitelny
    ;Zkuste pomoci funkce z jazyka C T_hit * get_pointer_to_hits(int * hits_cont) ziskat hodnotu ukazatele
    ;a vypsat si pomoci debugeru pamet, kde jsou ulozene souradnice
    ;Nasledne analyzujte, jak jsou souradnice zasahu v pameti poskladany
    
    push count_hits
    call _get_pointer_to_shots
    add esp, 4
     
    ;UKOL c.2
    ;Pomoci funkce @hit_check@8 zkontrolujte, zda doslo k zasahu,
    ;nasledne vypiste pomoci funkce printf text zacinajici na adresach hit_str nebo nohit_str
    ;Funkce je deklarovana jako: char hit_check(int *ships, int ship_count)
    ;int *ships - ukazatel pole poli s lodemi
    ;int ship_count - celkovy pocet lodi
    ;Pokud doslo k zasahu nejake lodi nejakou strelou, tak vrati 1, jinak 0
    ;Funkce mezi sebou porovnava vsechny lode a vsechny zasahy -> staci tuto funkci zavolat
    
    ;fastcall
    mov ecx, ships_data
    mov edx, 3
    call @hit_check@8
    
    cmp al,1
    jne nohit
    mov esi,hit_str
    jmp end_if
nohit:  
    mov esi,nohit_str
    end_if:  
    
    push esi
    call _printf
    add esp, 4
    
    ;UKOL c.4
    ;Vypiste pozici a rozmery prvni zasazene lodi do souboru isu.txt
    ;Poradi lodi berte podle indexu v poli struktur s lodemi
    ;Ukolem je ziskat ukazatel na pole souradnic vystrelu a provest zjisteni, zda doslo k zasahu lodi.
    ;Pokud doslo k zasahu lodi, prochazeni ukoncite a nasledne zapisete informace o lodi do souboru isu.txt
    
    ;Zavolm T_shot * get_pointer_to_shots(int * hits_cont)
    push count_hits
    call _get_pointer_to_shots
    add esp, 4
    mov edi, eax
    
    mov esi,0
cycle_hit:
    cmp esi,[count_hits]
    jge app_end
    
    mov ebx, 0
    mov edx, [edi+esi*4+4] ; y
    mov ecx, [edi+esi*4] ; x
    cycle:
	cmp ebx,[ship_count]
	jge app_end

        ;Podminka if((x_in>=x) && (y_in>=y) && (y_in<height+y) && (x_in<width+x)) {true} else {false}
	mov eax, ebx
	shl eax,4
	mov eax, [ships_data+eax]

	;x_in>=x
	cmp ecx, eax
	jnae else

	mov eax, ebx
	shl eax,4
	mov eax, [ships_data+eax+4]

	;y_in>=y
	cmp edx, eax
	jnae else

	;y_in<height+y
	mov eax, ebx
	shl eax,4
	push ebx
	mov ebx, [ships_data+eax+12]
	add ebx, [ships_data+eax+4]
	mov eax, ebx
	pop ebx

	cmp edx,eax
	jnb else

	;x_in<width+x
	mov eax, ebx
	shl eax,4
	push ebx
	mov ebx, [ships_data+eax+8]
	add ebx, [ships_data+eax]
	mov eax, ebx
	pop ebx

	cmp edx,eax
	jnb else

	;true
        ;DEBUG
        ;push esi
	;mov esi,hit_str
	;call WriteString
        ;pop esi
	;jmp first_shot

        else:
	inc ebx
	jmp cycle

        
        ;push esi
	;mov esi,nohit_str
	;call WriteString
        ;pop esi

        inc esi
        jmp cycle_hit
        jmp app_end
        
first_shot:
        
        mov eax, ebx
	shl eax,4
        mov ebx, [ships_data+eax]
        mov ecx, [ships_data+eax+4]
        mov edx, [ships_data+eax+8]
        mov edi, [ships_data+eax+12]
       
        push ebx
        push ecx
        push edx
        push edi
        
        ;fopen(char *file_name,char *fopen_flags) - FILE *-> eax
        push fopen_flags
        push file_name
        call _fopen
        add esp, 8
        
        pop edi
        pop edx
        pop ecx
        pop ebx
        
        ;v ESI mam ukazatel na soubor
        mov esi, eax
        ;vypsani pozice pres sprintf do bufferu
        push edi
        push edx
        push ecx
        push ebx
        push sprintf_format
        push str_buffer
        call _sprintf
        add esp, 24
        
        ;fwrite (char * str_buffer , sizeof(char), sizeof(buffer), esi);
        
        ;v ESI je ukazatel na otevreny soubor
        push esi
        ;v EAX je navratova hodnota z sprintf, ktera udava pocet zapsanych znaku do bufferu
        push eax
        ;zapisovani do souboru po 1B
        push 1
        ;retezec, ktery chci zapsat
        push str_buffer
        call _fwrite
        add esp, 16
        
        ;fclose(esi)
        ;zavru soubor
        push esi
        call _fclose
        add esp, 4 
 
app_end:

    ;UKOL c.3
    ;Vykreslete hraci pole pomoci funkce _print_ships
    ;Funkce je deklarovana jako: void print_ships(int area_x, int area_h, int *ships, int ship_count)
    push dword 4
    push ships_data
    push dword [area_w]
    push dword [area_h]
    
    call _print_ships
    xor eax, eax
    
    ;UKOL c.5
    ;Udelejte kontrolu, zda raketa nemiri mimo hraci plochu promena area_w a area_h
    ;Implementovano v ukolu c.1
    
    ret